=== debian/changelog ===
simgrid (4.1-1) unstable; urgency=medium

  * New upstream release: Breaking the seal (v4.0 was not the final release).
    - Allow one to unseal netzones to modify the platform even after
      the simulation start.
    - The model-checker can now report memory race conditions (see tutorial).
    - Pip builds should now work out of the box.
    - (+ the usual bug fixes overall, and improvements to the
       Java/Python bindings).

  * Run wrap-and-sort -astkb
  * d/control: bump Standards-version to 4.7.2.

 -- Martin Quinson <mquinson@debian.org>  Tue, 11 Nov 2025 23:27:12 +0100
